#include "svg.h"
#include <iostream>
#include <vector>
#include <math.h>
using namespace std;

void
svg_begin(double width, double height) {
    std::cout << "<?xml version='1.0' encoding='UTF-8'?>\n";
    std::cout << "<svg ";
    std::cout << "width='" << width << "' ";
    std::cout << "height='" << height << "' ";
    std::cout << "viewBox='0 0 " << width << " " << height << "' ";
    std::cout << "xmlns='http://www.w3.org/2000/svg'>\n";
}

void
svg_text(double left, double baseline, std::string text) {
    std::cout << "<text x='"<< left <<"' y='"<< baseline <<"'>"<< text <<"</text>";
}

void svg_rect(double x, double y, double width, double height,std::string stroke = "black", std::string fill = "green"){
    std::cout<< "<rect x='"<< x <<"' y='"<< y <<"' width='"<< width <<"' height='"<< height <<"' stroke = '" << stroke <<"' fill = '" << fill <<"' />";
}
void
svg_end() {
    std::cout << "</svg>\n";
}

void
show_histogram_svg(std::vector<size_t> bins,size_t max_count) {
    const auto IMAGE_WIDTH = 400;
    const auto IMAGE_HEIGHT = 300;
    const auto TEXT_LEFT = 20;
    const auto TEXT_BASELINE = 20;
    const auto TEXT_WIDTH = 50;
    const auto BIN_HEIGHT = 30;
    const auto SCALE = 10;
    const auto BLOCK_WIDTH = (IMAGE_WIDTH - TEXT_WIDTH);


    svg_begin(IMAGE_WIDTH, IMAGE_HEIGHT);

    double top = 0;

    if((SCALE*max_count)>BLOCK_WIDTH)
    {
        for (size_t i = 0; i < bins.size(); i++) {
        const double bin_width = BLOCK_WIDTH * (bins[i]/max_count);
        const auto TEXT_LEFT_PROCENT = SCALE+TEXT_WIDTH+20;
        svg_text(TEXT_LEFT, top + TEXT_BASELINE, std::to_string(bins[i]));
        svg_rect(TEXT_WIDTH, top, bin_width, BIN_HEIGHT);

        top += BIN_HEIGHT;
        }}
    else{
    for (size_t i = 0; i < bins.size(); i++) {
        const double bin_width = bins[i] * SCALE;
        const auto TEXT_LEFT_PROCENT = (max_count*SCALE)+TEXT_WIDTH+20;
        svg_text(TEXT_LEFT, top + TEXT_BASELINE, std::to_string(bins[i]));
        svg_rect(TEXT_WIDTH, top, bin_width, BIN_HEIGHT);

        top += BIN_HEIGHT;
    }
    svg_end();
    }
    }
